sc::TwoBodyMOIntsTransform_ijxy Class Reference

TwoBodyMOIntsTransform_ijxy computes (ij|xy) integrals using parallel integrals-direct AO->MO transformation. More...

`#include <transform_ijxy.h>`

Inheritance diagram for sc::TwoBodyMOIntsTransform_ijxy:
[legend]
Collaboration diagram for sc::TwoBodyMOIntsTransform_ijxy:
[legend]

## Public Member Functions

| TwoBodyMOIntsTransform_ijxy (StateIn &)
| TwoBodyMOIntsTransform_ijxy (const std::string &name, const Ref< MOIntsTransformFactory > &factory, const Ref< MOIndexSpace > &space1, const Ref< MOIndexSpace > &space2, const Ref< MOIndexSpace > &space3, const Ref< MOIndexSpace > &space4)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
std::string | type () const
| Implementation of TwoBodyMOIntsTransform::type()
const size_t | memgrp_blksize () const
| Returns the number of bytes allocated for each ij-block of integrals of one type in MemoryGrp.
void | compute ()
| Computes transformed integrals.
void | check_int_symm (double threshold=TwoBodyMOIntsTransform::zero_integral) const throw (ProgrammingError)
| Check symmetry of transformed integrals.
Public Member Functions inherited from sc::TwoBodyMOIntsTransform
| TwoBodyMOIntsTransform (StateIn &)
| TwoBodyMOIntsTransform (const std::string &name, const Ref< MOIntsTransformFactory > &factory, const Ref< MOIndexSpace > &space1, const Ref< MOIndexSpace > &space2, const Ref< MOIndexSpace > &space3, const Ref< MOIndexSpace > &space4)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
std::string | name () const
| Returns the name of the transform.
Ref< MemoryGrp > | mem () const
| Returns the MemoryGrp object.
Ref< MessageGrp > | msg () const
| Returns the MessageGrp object.
Ref< R12IntsAcc > | ints_acc () const
| Returns the integrals accumulator object.
Ref< MOIndexSpace > | space1 () const
| Returns MOIndexSpace object 1.
Ref< MOIndexSpace > | space2 () const
| Returns MOIndexSpace object 2.
Ref< MOIndexSpace > | space3 () const
| Returns MOIndexSpace object 3.
Ref< MOIndexSpace > | space4 () const
| Returns MOIndexSpace object 4.
double | print_percent () const
| Returns the update print frequency.
int | batchsize () const
| Returns the batchsize for each pass of the transformation.
int | debug () const
| Returns the debug level.
bool | dynamic () const
| Returns whether to use dynamic load balancing.
int | num_te_types () const
| Returns the number of types of two body integrals computed.
void | set_top_mole (const Ref< MolecularEnergy > &top_mole)
| Specifies the top-level MolecularEnergy object to use for checkpointing.
void | set_num_te_types (const int num_te_types)
| Specifies how many integral types computed by TwoBodyInt to be transformed Default is 1. More...
void | set_memory (const size_t memory)
void | set_debug (int debug)
void | set_dynamic (bool dynamic)
void | set_print_percent (double print_percent)
virtual void | obsolete ()
| Make the transform obsolete. Next call to compute() will recompute.
DistShellPair::SharedData * | shell_pair_data ()
| Returns a that data that must be shared between all DistShellPair objects. More...
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::TwoBodyMOIntsTransform
unsigned int | restart_orbital () const
| returns index in range of space1_ where to start the transformation
void | init_vars ()
void | reinit_acc ()
void | alloc_mem (const size_t localmem)
void | dealloc_mem ()
int | compute_transform_batchsize_ (size_t mem_static, int rank_i)
void | memory_report (std::ostream &os=ExEnv::out0()) const
| Generates a report on memory for the transform : user-specified limits, projected and actual use. More...
void | mospace_report (std::ostream &os=ExEnv::out0()) const
| Generates a report on MO spaces for the transform. More...
void | print_header (std::ostream &os=ExEnv::out0()) const
| Prints out standard header. More...
void | print_footer (std::ostream &os=ExEnv::out0()) const
| Prints out standard footer. More...
Static Protected Member Functions inherited from sc::TwoBodyMOIntsTransform
static int | compute_nij (const int rank_i, const int rank_j, const int nproc, const int me)
Protected Attributes inherited from sc::TwoBodyMOIntsTransform
std::string | name_
Ref< MOIntsTransformFactory > | factory_
Ref< MolecularEnergy > | top_mole_
Ref< MessageGrp > | msg_
Ref< MemoryGrp > | mem_
Ref< ThreadGrp > | thr_
Ref< R12IntsAcc > | ints_acc_
Ref< MOIndexSpace > | space1_
Ref< MOIndexSpace > | space2_
Ref< MOIndexSpace > | space3_
Ref< MOIndexSpace > | space4_
int | num_te_types_
size_t | memory_
bool | dynamic_
double | print_percent_
DistShellPair::SharedData | spdata_
int | debug_
MOIntsTransformFactory::StoreMethod | ints_method_
std::string | file_prefix_
size_t | mem_static_
int | batchsize_
int | npass_
Static Protected Attributes inherited from sc::TwoBodyMOIntsTransform
static const double | zero_integral = 1.0e-12
| By default, integrals smaller than zero_integral are considered zero. More...

## Detailed Description

TwoBodyMOIntsTransform_ijxy computes (ij|xy) integrals using parallel integrals-direct AO->MO transformation.

## Member Function Documentation

void sc::TwoBodyMOIntsTransform_ijxy::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

The documentation for this class was generated from the following file:

- transform_ijxy.h